## tiff 4.5.0

=== libtiff/CMakeLists.txt ===
# CMake build for libtiff
#
# Copyright © 2015 Open Microscopy Environment / University of Dundee
# Written by Roger Leigh <rleigh@codelibre.net>
#
# Permission to use, copy, modify, distribute, and sell this software and
# its documentation for any purpose is hereby granted without fee, provided
# that (i) the above copyright notices and this permission notice appear in
# all copies of the software and related documentation, and (ii) the names of
# Sam Leffler and Silicon Graphics may not be used in any advertising or
# publicity relating to the software without the specific, prior written
# permission of Sam Leffler and Silicon Graphics.
#
# THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
# EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
# WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
#
# IN NO EVENT SHALL SAM LEFFLER OR SILICON GRAPHICS BE LIABLE FOR
# ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
# OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
# WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF
# LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
# OF THIS SOFTWARE.

# Generate headers
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tif_config.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/tif_config.h
               @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tiffconf.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/tiffconf.h
               @ONLY)

set(tiff_public_HEADERS
        tiff.h
        tiffio.h
        tiffvers.h
        ${CMAKE_CURRENT_BINARY_DIR}/tiffconf.h)

set(tiff_private_HEADERS
        t4.h
        tif_dir.h
        tif_predict.h
        tiffiop.h
        uvcode.h
        ${CMAKE_CURRENT_BINARY_DIR}/tif_config.h)


add_library(tiff libtiff.def)
add_library(TIFF::TIFF ALIAS tiff)

target_sources(tiff PRIVATE
        ${tiff_public_HEADERS}
        ${tiff_private_HEADERS}
        tif_aux.c
        tif_close.c
        tif_codec.c
        tif_color.c
        tif_compress.c
        tif_dir.c
        tif_dirinfo.c
        tif_dirread.c
        tif_dirwrite.c
        tif_dumpmode.c
        tif_error.c
        tif_extension.c
        tif_fax3.c
        tif_fax3sm.c
        tif_flush.c
        tif_getimage.c
        tif_hash_set.c
        tif_jbig.c
        tif_jpeg.c
        tif_jpeg_12.c
        tif_lerc.c
        tif_luv.c
        tif_lzma.c
        tif_lzw.c
        tif_next.c
        tif_ojpeg.c
        tif_open.c
        tif_packbits.c
        tif_pixarlog.c
        tif_predict.c
        tif_print.c
        tif_read.c
        tif_strip.c
        tif_swab.c
        tif_thunder.c
        tif_tile.c
        tif_version.c
        tif_warning.c
        tif_webp.c
        tif_write.c
        tif_zip.c
        tif_zstd.c)

if(USE_WIN32_FILEIO)
  target_sources(tiff PRIVATE tif_win32.c)
else()
  target_sources(tiff PRIVATE tif_unix.c)
endif()

target_include_directories(tiff
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    PRIVATE
        ${TIFF_INCLUDES}
)

set(tiff_libs_private_list "") # cmake list
set(tiff_requires_private "") # cmake string

if(ZIP_SUPPORT)
  target_link_libraries(tiff PRIVATE ZLIB::ZLIB)
  string(APPEND tiff_requires_private " zlib")
endif()
if(ZIP_SUPPORT AND LIBDEFLATE_SUPPORT)
  target_link_libraries(tiff PRIVATE Deflate::Deflate)
  list(APPEND tiff_libs_private_list "${Deflate_LIBRARY}")
endif()
if(JPEG_SUPPORT)
  target_link_libraries(tiff PRIVATE JPEG::JPEG)
  string(APPEND tiff_requires_private " libjpeg")
  if(HAVE_JPEGTURBO_DUAL_MODE_8_12)
    target_compile_definitions(tiff PRIVATE HAVE_JPEGTURBO_DUAL_MODE_8_12)
  elseif(JPEG_DUAL_MODE_8_12)
    target_include_directories(tiff PRIVATE ${JPEG12_INCLUDE_DIR})
    target_link_libraries(tiff PRIVATE ${JPEG12_LIBRARIES})
  endif()
endif()
if(JBIG_SUPPORT)
  target_link_libraries(tiff PRIVATE JBIG::JBIG)
  list(APPEND tiff_libs_private_list "${JBIG_LIBRARY}")
endif()
if(LERC_SUPPORT)
  target_link_libraries(tiff PRIVATE LERC::LERC)
  list(APPEND tiff_libs_private_list "${LERC_LIBRARY}")
  if(NOT BUILD_SHARED_LIBS)
    set_target_properties(tiff PROPERTIES COMPILE_DEFINITIONS LERC_STATIC)
  endif()
endif()
if(LZMA_SUPPORT)
  target_link_libraries(tiff PRIVATE LibLZMA::LibLZMA)
  string(APPEND tiff_requires_private " liblzma")
endif()
if(ZSTD_SUPPORT)
  target_link_libraries(tiff PRIVATE ZSTD::ZSTD)
  string(APPEND tiff_requires_private " libzstd")
endif()
if(WEBP_SUPPORT)
  target_link_libraries(tiff PRIVATE WebP::WebP)
  string(APPEND tiff_requires_private " libwebp")
endif()
if(CMath_LIBRARY)
  target_link_libraries(tiff PRIVATE CMath::CMath)
  list(APPEND tiff_libs_private_list "${CMath_LIBRARY}")
endif()

set(tiff_libs_private_list "${tiff_libs_private_list}" PARENT_SCOPE)
set(tiff_requires_private "${tiff_requires_private}" PARENT_SCOPE)

set_target_properties(tiff PROPERTIES SOVERSION ${SO_COMPATVERSION})
if(NOT CYGWIN)
    # This property causes shared libraries on Linux to have the full version
    # encoded into their final filename.  We disable this on Cygwin because
    # it causes cygz-${TIFF_FULL_VERSION}.dll to be created when cygz.dll
    # seems to be the default.
    set_target_properties(tiff PROPERTIES VERSION ${SO_VERSION})
endif()
if(HAVE_LD_VERSION_SCRIPT)
  set_target_properties(tiff PROPERTIES LINK_FLAGS
                        "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/libtiff.map")
endif()

if(tiff-install)
  export(TARGETS tiff NAMESPACE TIFF:: FILE "${CMAKE_CURRENT_BINARY_DIR}/libtiffTargets.cmake")
  install(TARGETS tiff EXPORT TiffTargets
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

  install(FILES ${tiff_public_HEADERS}
          DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

  set(TIFF_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/tiff)
  install(EXPORT TiffTargets
          FILE TiffTargets.cmake
          NAMESPACE TIFF::
          DESTINATION ${TIFF_CONFIGDIR}
  )
endif()

if(CXX_SUPPORT)
  set(tiffxx_HEADERS
          tiffio.hxx)

  # No .def file for this library.
  if (WIN32)
      add_library(tiffxx STATIC ../placeholder.h)
  else()
      add_library(tiffxx ../placeholder.h)
  endif()

  add_library(TIFF::CXX ALIAS tiffxx)

  target_sources(tiffxx PRIVATE
          ${tiffxx_HEADERS}
          tif_stream.cxx)
  target_link_libraries(tiffxx tiff)
  set_target_properties(tiffxx PROPERTIES SOVERSION ${SO_COMPATVERSION})
  if(NOT CYGWIN)
    # This property causes shared libraries on Linux to have the full version
    # encoded into their final filename.  We disable this on Cygwin because
    # it causes cygz-${TIFF_FULL_VERSION}.dll to be created when cygz.dll
    # seems to be the default.
    set_target_properties(tiffxx PROPERTIES VERSION ${SO_VERSION})
  endif()
  if(HAVE_LD_VERSION_SCRIPT)
    set_target_properties(tiffxx PROPERTIES LINK_FLAGS
                          "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/libtiffxx.map")
  endif()

  if(tiff-install)
    install(TARGETS tiffxx
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

    install(FILES ${tiffxx_HEADERS}
            DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
  endif()
      
endif()

if(NOT CMAKE_CROSSCOMPILING)
  add_executable(tiff_mkg3states ../placeholder.h)
  target_sources(tiff_mkg3states PRIVATE mkg3states.c tif_fax3.h)
  target_link_libraries(tiff_mkg3states tiff tiff_port)

  add_custom_target(tiff_faxtable
          DEPENDS tiff_mkg3states
          COMMAND ${CMAKE_COMMAND} -E rm "tif_fax3sm.c"
          COMMAND tiff_mkg3states -b -c const "tif_fax3sm.c"
          WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

=== test/CMakeLists.txt ===
# CMake build for libtiff
#
# Copyright © 2015 Open Microscopy Environment / University of Dundee
# Written by Roger Leigh <rleigh@codelibre.net>
#
# Permission to use, copy, modify, distribute, and sell this software and
# its documentation for any purpose is hereby granted without fee, provided
# that (i) the above copyright notices and this permission notice appear in
# all copies of the software and related documentation, and (ii) the names of
# Sam Leffler and Silicon Graphics may not be used in any advertising or
# publicity relating to the software without the specific, prior written
# permission of Sam Leffler and Silicon Graphics.
#
# THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
# EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
# WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
#
# IN NO EVENT SHALL SAM LEFFLER OR SILICON GRAPHICS BE LIABLE FOR
# ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
# OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
# WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF
# LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
# OF THIS SOFTWARE.

# Images for tiff2bw (8-bit RGB only)
set(RGBIMAGES
    images/palette-1c-8b.tiff
    images/rgb-3c-8b.tiff
    images/quad-lzw-compat.tiff
)

# This list should contain all of the TIFF files in the 'images'
# subdirectory which are intended to be used as input images for
# tests.  All of these files should use the extension ".tiff".
set(TIFFIMAGES
    images/custom_dir_EXIF_GPS.tiff
    images/logluv-3c-16b.tiff
    images/minisblack-1c-16b.tiff
    images/minisblack-1c-8b.tiff
    images/minisblack-2c-8b-alpha.tiff
    images/miniswhite-1c-1b.tiff
    images/palette-1c-1b.tiff
    images/palette-1c-4b.tiff
    images/palette-1c-8b.tiff
    images/rgb-3c-16b.tiff
    images/rgb-3c-8b.tiff
    images/quad-lzw-compat.tiff
    images/lzw-single-strip.tiff
    images/testfax4.tiff)
# TIFF images using old-jpeg.  Unused unless JPEG support is enabled.
set(TIFFIMAGES_OJPEG)

if(JPEG_SUPPORT)
    list(APPEND TIFFIMAGES images/quad-tile.jpg.tiff)
endif()

if (OJPEG_SUPPORT)
    list(APPEND TIFFIMAGES_OJPEG
        images/ojpeg_zackthecat_subsamp22_single_strip.tiff
        images/ojpeg_chewey_subsamp21_multi_strip.tiff
        images/ojpeg_single_strip_no_rowsperstrip.tiff
    )
endif()

set(BMPIMAGES
    images/palette-1c-8b.bmp
    images/rgb-3c-8b.bmp)

set(GIFIMAGES
    images/palette-1c-8b.gif)

set(PNMIMAGES
    images/minisblack-1c-8b.pgm
    images/miniswhite-1c-1b.pbm
    images/rgb-3c-16b.ppm
    images/rgb-3c-8b.ppm)

# All uncompressed image files
set(UNCOMPRESSEDIMAGES
    images/minisblack-1c-16b.tiff
    images/minisblack-1c-8b.tiff
    images/miniswhite-1c-1b.tiff
    images/palette-1c-1b.tiff
    images/palette-1c-4b.tiff
    images/palette-1c-8b.tiff
    images/rgb-3c-8b.tiff)

# This list should include all of the files in the 'images'
# subdirectory which are intended to be distributed.  This may include
# files which are not currently used by the tests.
set(IMAGES_EXTRA_DIST
    images/README.txt
    images/miniswhite-1c-1b.g3
    ${BMPIMAGES}
    ${GIFIMAGES}
    ${PNMIMAGES}
    ${TIFFIMAGES})

set(noinst_HEADERS tifftest.h)

set(simple_tests)

add_executable(test_signed_tags ../placeholder.h)
target_sources(test_signed_tags PRIVATE test_signed_tags.c)
target_link_libraries(test_signed_tags PRIVATE tiff tiff_port)
list(APPEND simple_tests test_signed_tags)

add_executable(ascii_tag ../placeholder.h)
target_sources(ascii_tag PRIVATE ascii_tag.c)
target_link_libraries(ascii_tag PRIVATE tiff tiff_port)
list(APPEND simple_tests ascii_tag)

add_executable(long_tag ../placeholder.h)
target_sources(long_tag PRIVATE long_tag.c check_tag.c)
target_link_libraries(long_tag PRIVATE tiff tiff_port)
list(APPEND simple_tests long_tag)

add_executable(short_tag ../placeholder.h)
target_sources(short_tag PRIVATE short_tag.c check_tag.c)
target_link_libraries(short_tag PRIVATE tiff tiff_port)
list(APPEND simple_tests short_tag)

add_executable(strip_rw ../placeholder.h)
target_sources(strip_rw PRIVATE strip_rw.c strip.c test_arrays.c test_arrays.h)
target_link_libraries(strip_rw PRIVATE tiff tiff_port)
list(APPEND simple_tests strip_rw)

add_executable(rewrite ../placeholder.h)
target_sources(rewrite PRIVATE rewrite_tag.c)
target_link_libraries(rewrite PRIVATE tiff tiff_port)
list(APPEND simple_tests rewrite)

if(JPEG_SUPPORT)
  add_executable(raw_decode ../placeholder.h)
  target_sources(raw_decode PRIVATE raw_decode.c)
  target_link_libraries(raw_decode PRIVATE tiff tiff_port JPEG::JPEG)
  list(APPEND simple_tests raw_decode)
endif()

add_executable(custom_dir ../placeholder.h)
target_sources(custom_dir PRIVATE custom_dir.c)
target_link_libraries(custom_dir PRIVATE tiff tiff_port)
list(APPEND simple_tests custom_dir)

# Uses private functions from static library
if(NOT BUILD_SHARED_LIBS)
  add_executable(rational_precision2double ../placeholder.h)
  target_sources(rational_precision2double PRIVATE rational_precision2double.c)
  target_link_libraries(rational_precision2double PRIVATE tiff tiff_port)
  list(APPEND simple_tests rational_precision2double)
endif()

add_executable(custom_dir_EXIF_231 ../placeholder.h)
target_sources(custom_dir_EXIF_231 PRIVATE custom_dir_EXIF_231.c)
target_link_libraries(custom_dir_EXIF_231 PRIVATE tiff tiff_port)
list(APPEND simple_tests custom_dir_EXIF_231)

add_executable(defer_strile_loading ../placeholder.h)
target_sources(defer_strile_loading PRIVATE defer_strile_loading.c)
target_link_libraries(defer_strile_loading PRIVATE tiff tiff_port)
list(APPEND simple_tests defer_strile_loading)

add_executable(defer_strile_writing ../placeholder.h)
target_sources(defer_strile_writing PRIVATE defer_strile_writing.c)
target_link_libraries(defer_strile_writing PRIVATE tiff tiff_port)
list(APPEND simple_tests defer_strile_writing)

add_executable(test_directory ../placeholder.h)
target_sources(test_directory PRIVATE test_directory.c)
target_link_libraries(test_directory PRIVATE tiff tiff_port)
list(APPEND simple_tests test_directory)

add_executable(testtypes ../placeholder.h)
target_sources(testtypes PRIVATE testtypes.c)
target_link_libraries(testtypes PRIVATE tiff tiff_port)
list(APPEND simple_tests testtypes)

add_executable(test_open_options ../placeholder.h)
target_sources(test_open_options PRIVATE test_open_options.c)
target_link_libraries(test_open_options PRIVATE tiff tiff_port)
list(APPEND simple_tests test_open_options)

add_executable(test_append_to_strip ../placeholder.h)
target_sources(test_append_to_strip PRIVATE test_append_to_strip.c)
target_link_libraries(test_append_to_strip PRIVATE tiff tiff_port)
list(APPEND simple_tests test_append_to_strip)

add_executable(test_ifd_loop_detection ../placeholder.h)
target_sources(test_ifd_loop_detection PRIVATE test_ifd_loop_detection.c)
target_link_libraries(test_ifd_loop_detection PRIVATE tiff tiff_port)
target_compile_definitions(test_ifd_loop_detection PRIVATE SOURCE_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\")
list(APPEND simple_tests test_ifd_loop_detection)

if(WEBP_SUPPORT AND EMSCRIPTEN)
  # Emscripten is pretty finnicky about linker flags.
  # It needs --shared-memory if and only if atomics or bulk-memory is used.
  foreach(target
          ascii_tag
          long_tag
          short_tag
          strip_rw
          rewrite
          custom_dir
          defer_strile_loading
          defer_strile_writing
          )
    target_link_options(${target} PUBLIC "-Wl,--shared-memory")
  endforeach()
  if(JPEG_SUPPORT)
    target_link_options(raw_decode PUBLIC "-Wl,--shared-memory")
  endif()
endif()

set(TEST_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/output")
file(MAKE_DIRECTORY "${TEST_OUTPUT}")

set(tiff_test_extra_args
    "-DTIFFCP=$<TARGET_FILE:tiffcp>"
    "-DTIFFINFO=$<TARGET_FILE:tiffinfo>"
    "-DTIFFSPLIT=$<TARGET_FILE:tiffsplit>"
    "-DLIBTIFF=$<TARGET_FILE:tiff>")
if(WIN32)
  list(APPEND tiff_test_extra_args "-DWIN32=${WIN32}")
endif()
if(CYGWIN)
  list(APPEND tiff_test_extra_args "-DCYGWIN=${CYGWIN}")
endif()

function(tiff_test_convert name command1 command2 command3 infile outfile validate)
  add_test(NAME "${name}"
           COMMAND "${CMAKE_COMMAND}"
           "-DCONVERT_COMMAND1=${command1}"
           "-DCONVERT_COMMAND2=${command2}"
           "-DCONVERT_COMMAND3=${command3}"
           "-DINFILE=${infile}"
           "-DOUTFILE=${outfile}"
           "-DVALIDATE=${validate}"
           ${tiff_test_extra_args}
           -P "${CMAKE_CURRENT_SOURCE_DIR}/TiffTest.cmake")
endfunction()

function(tiff_test_stdout name suffix command infile outfile)
  if (suffix)
     set(name "${name}-${suffix}")
  endif()
  add_test(NAME "${name}"
           COMMAND "${CMAKE_COMMAND}"
           "-DSTDOUT_COMMAND=${command}"
           "-DINFILE=${infile}"
           "-DOUTFILE=${outfile}"
           ${tiff_test_extra_args}
           -P "${CMAKE_CURRENT_SOURCE_DIR}/TiffTest.cmake")
endfunction()

function(tiff_test_stdout_noargs name command)
  add_test(NAME "${name}"
          COMMAND "${CMAKE_COMMAND}"
          "-DSTDOUT_COMMAND=$<TARGET_FILE:${command}>"
          ${tiff_test_extra_args}
          -P "${CMAKE_CURRENT_SOURCE_DIR}/TiffTest.cmake"
          WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  set_tests_properties("${name}" PROPERTIES ENVIRONMENT
          "srcdir=${CMAKE_CURRENT_SOURCE_DIR}")
endfunction()

function(tiff_test_reader name command infile)
  add_test(NAME "${name}"
           COMMAND "${CMAKE_COMMAND}"
           "-DREADER_COMMAND=${command}"
           "-DINFILE=${infile}"
           ${tiff_test_extra_args}
           -P "${CMAKE_CURRENT_SOURCE_DIR}/TiffTest.cmake")
endfunction()

function(add_convert_test_multi commandname1 commandname2 commandname3
      categoryname commandargs1 commandargs2 commandargs3
      image validate)
  string(REPLACE " " "^" escaped_commandargs1 "${commandargs1}")
  string(REPLACE " " "^" escaped_commandargs2 "${commandargs2}")
  string(REPLACE " " "^" escaped_commandargs3 "${commandargs3}")
  get_filename_component(name "${image}" NAME)
  get_filename_component(base "${image}" NAME_WE)
  set(testname "${commandname1}-${categoryname}-${base}")
  if(commandname1)
    set(command1
        "$<TARGET_FILE:${commandname1}>^${escaped_commandargs1}")
  else()
    set(command1)
  endif()
  if(commandname2)
    set(command2
        "$<TARGET_FILE:${commandname2}>^${escaped_commandargs2}")
  else()
    set(command2)
  endif()
  if(commandname3)
    set(command3
        "$<TARGET_FILE:${commandname3}>^${escaped_commandargs3}")
  else()
    set(command3)
  endif()
  set(infile "${CMAKE_CURRENT_SOURCE_DIR}/${image}")
  set(outfile "${TEST_OUTPUT}/${commandname1}-${categoryname}-${base}.tiff")
  tiff_test_convert("${testname}" "${command1}" "${command2}" "${command3}"
                    "${infile}" "${outfile}" "${validate}")
endfunction()

function(add_convert_test commandname
      categoryname commandargs
      image validate)
    add_convert_test_multi("${commandname}" "" ""
                           "${categoryname}" "${commandargs}" "" ""
                           "${image}" "${validate}")
endfunction()

function(add_convert_tests_multi commandname1 commandname2 commandname3
      categoryname
      commandargs1 commandargs2 commandargs3
      images validate)
  foreach(file ${${images}})
    add_convert_test_multi("${commandname1}" "${commandname2}"
                           "${commandname3}" "${categoryname}"
                           "${commandargs1}" "${commandargs2}"
                           "${commandargs3}" "${file}" "${validate}")
  endforeach()
endfunction()

function(add_convert_tests commandname categoryname commandargs images validate)
  foreach(file ${${images}})
    add_convert_test("${commandname}" "${categoryname}"
                     "${commandargs}" "${file}" "${validate}")
  endforeach()
endfunction()

=== debian/changelog ===
tiff (4.5.0-6+deb12u3) bookworm-security; urgency=medium

  * CVE-2025-9900

 -- Moritz Mühlenhoff <jmm@debian.org>  Sat, 27 Sep 2025 17:42:42 +0200

tiff (4.5.0-6+deb12u2) bookworm; urgency=medium

  * CVE-2023-2908
  * CVE-2023-3618 (Closes: #1040945)
  * CVE-2023-25433
  * CVE-2023-26965
  * CVE-2023-26966
  * CVE-2023-52356 (Closes: #1061524)
  * CVE-2024-7006 (Closes: #1078648)

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 03 Jan 2025 14:39:11 +0100

tiff (4.5.0-6+deb12u1) bookworm-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Fix a memory leak in tiffcrop (CVE-2023-3576)
  * Fix buffer overflows in tiffcp and raw2tiff
    (CVE-2023-40745, CVE-2023-41175)

 -- Aron Xu <aron@debian.org>  Thu, 23 Nov 2023 16:06:18 +0800

tiff (4.5.0-6) unstable; urgency=high

  * Backport security fix for CVE-2023-2731, NULL pointer dereference flaw in
    LZWDecode() (closes: #1036282).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 18 May 2023 18:20:39 +0200

tiff (4.5.0-5) unstable; urgency=high

  * Backport fix for tiffcrop correctly update buffersize after
    rotateImage() .
  * Backport fix for TIFFClose() avoid NULL pointer dereferencing.
  * Backport security fix for CVE-2023-0800, CVE-2023-0801, CVE-2023-0802,
    CVE-2023-0803 and CVE-2023-0804, an out-of-bounds write in tiffcrop
    allows attackers to cause a denial-of-service via a crafted tiff file.
  * Backport security fix for CVE-2023-0795, CVE-2023-0796, CVE-2023-0797,
    CVE-2023-0798 and CVE-2023-0799, an out-of-bounds read in tiffcrop allows
    attackers to cause a denial-of-service via a crafted tiff file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 19 Feb 2023 08:46:38 +0100

tiff (4.5.0-4) unstable; urgency=high

  * Backport security fix for CVE-2022-48281, heap-based buffer overflow in
    processCropSelections() (closes: #1029653).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 25 Jan 2023 18:28:55 +0100

tiff (4.5.0-3) unstable; urgency=medium

  * Don't use smartquotes for Sphinx (closes: #1028456).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 12 Jan 2023 17:45:09 +0100

tiff (4.5.0-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 10 Jan 2023 23:02:27 +0100

tiff (4.5.0-1) experimental; urgency=medium

  * New upstream release.
  * Backport upstream fix to add a tif_config.h include.
  * Backport upstream fix for TIFFWriteDirectorySec(): avoid harmless
    unsigned integer overflow.
  * Backport upstream fix for TIFFSetDirectory(): avoid harmless unsigned
    integer overflow.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 17 Dec 2022 14:03:44 +0100

tiff (4.5.0~rc3+git221213-1) experimental; urgency=medium

  * New git snapshot release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 14 Dec 2022 17:36:48 +0100

tiff (4.5.0~rc1+git221213-1) experimental; urgency=medium

  * New git snapshot release.
  * Update libtiff-dev dependency.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 13 Dec 2022 16:54:10 +0100

tiff (4.5.0~rc1-1) experimental; urgency=medium

  * New upstream release candidate version.
  * Library transition from libtiff{,xx}5 to libtiff{,xx}6 .
  * Link common JavaScript files to packaged ones in libtiff-doc.
  * Update Standards-Version to 4.6.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 10 Dec 2022 10:16:36 +0100

tiff (4.4.0-6) unstable; urgency=high

  * Backport security fix for CVE-2022-2519, double free or corruption in
    rotateImage() (closes: #1024670).
  * Backport security fix for CVE-2022-2520, sysmalloc assertion fail in
    rotateImage().
  * Backport security fix for CVE-2022-2521, invalid pointer free operation
    in TIFFClose().
  * Backport security fix for CVE-2022-2953, out-of-bounds read in
    extractImageSection().
  * Backport security fix for CVE-2022-3970, fix (unsigned) integer overflow
    on strips/tiles > 2 GB in TIFFReadRGBATileExt() (closes: #1024737).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 24 Nov 2022 17:54:18 +0100

tiff (4.4.0-5) unstable; urgency=high

  * Backport security fix for CVE-2022-3597, CVE-2022-3626 and CVE-2022-3627,
    out of bounds write and denial of service via a crafted TIFF file.
  * Backport security fix for CVE-2022-3570, multiple heap buffer overflows
    via crafted TIFF file.
  * Backport security fix for CVE-2022-3599, denial-of-service via a crafted
    TIFF file.
  * Backport security fix for CVE-2022-3598, denial-of-service via a crafted
    TIFF file (closes: #1022555).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 23 Oct 2022 22:38:15 +0200

=== debian/watch ===
version=4
opts=uversionmangle=s/^(SNAPSHOT|RELEASE)\.//;s/(\d+)[_-](\d+)[_-](\d+)/\$1.\$2.\$3/;s/(\d+)[_-](\d+)/\$1.\$2/;s/(\d)[_\.\-\+]?((rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/;s/(\d)[_\.\-\+]?RC[\-\.]?(\d*)$/$1~rc$2/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//i \
https://gitlab.com/libtiff/libtiff/-/tags \
(?:|.*/)libtiff[_-]?[vV]?(\d\S*)@ARCHIVE_EXT@

## tiff 4.5.1%2Bgit230720

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,9 @@
     images/rgb-3c-8b.tiff
     images/quad-lzw-compat.tiff
     images/lzw-single-strip.tiff
-    images/testfax4.tiff)
+    images/testfax4.tiff
+    images/testfax3_bug_513.tiff
+)
 # TIFF images using old-jpeg.  Unused unless JPEG support is enabled.
 set(TIFFIMAGES_OJPEG)
 
@@ -148,6 +150,15 @@
   target_sources(rational_precision2double PRIVATE rational_precision2double.c)
   target_link_libraries(rational_precision2double PRIVATE tiff tiff_port)
   list(APPEND simple_tests rational_precision2double)
+  
+  add_executable(test_write_read_tags ../placeholder.h)
+  target_sources(test_write_read_tags PRIVATE test_write_read_tags.c)
+  target_link_libraries(test_write_read_tags PRIVATE tiff)
+  list(APPEND simple_tests test_write_read_tags)
+  add_executable(test_transferfunction_write_read ../placeholder.h)
+  target_sources(test_transferfunction_write_read PRIVATE test_transferfunction_write_read.c)
+  target_link_libraries(test_transferfunction_write_read PRIVATE tiff)
+  list(APPEND simple_tests test_transferfunction_write_read)
 endif()
 
 add_executable(custom_dir_EXIF_231 ../placeholder.h)
@@ -214,11 +225,14 @@
 set(TEST_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/output")
 file(MAKE_DIRECTORY "${TEST_OUTPUT}")
 
-set(tiff_test_extra_args
-    "-DTIFFCP=$<TARGET_FILE:tiffcp>"
-    "-DTIFFINFO=$<TARGET_FILE:tiffinfo>"
-    "-DTIFFSPLIT=$<TARGET_FILE:tiffsplit>"
-    "-DLIBTIFF=$<TARGET_FILE:tiff>")
+set(tiff_test_extra_args "-DLIBTIFF=$<TARGET_FILE:tiff>")
+
+if(tiff-tools)
+  list(APPEND tiff_test_extra_args "-DTIFFCP=$<TARGET_FILE:tiffcp>")
+  list(APPEND tiff_test_extra_args "-DTIFFINFO=$<TARGET_FILE:tiffinfo>")
+  list(APPEND tiff_test_extra_args "-DTIFFSPLIT=$<TARGET_FILE:tiffsplit>")
+endif()
+
 if(WIN32)
   list(APPEND tiff_test_extra_args "-DWIN32=${WIN32}")
 endif()
@@ -313,22 +327,3 @@
                            "${image}" "${validate}")
 endfunction()
 
-function(add_convert_tests_multi commandname1 commandname2 commandname3
-      categoryname
-      commandargs1 commandargs2 commandargs3
-      images validate)
-  foreach(file ${${images}})
-    add_convert_test_multi("${commandname1}" "${commandname2}"
-                           "${commandname3}" "${categoryname}"
-                           "${commandargs1}" "${commandargs2}"
-                           "${commandargs3}" "${file}" "${validate}")
-  endforeach()
-endfunction()
-
-function(add_convert_tests commandname categoryname commandargs images validate)
-  foreach(file ${${images}})
-    add_convert_test("${commandname}" "${categoryname}"
-                     "${commandargs}" "${file}" "${validate}")
-  endforeach()
-endfunction()
-

=== debian/control ===
Source: tiff
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13),
               freeglut3-dev,
               libglu1-mesa-dev,
               libjbig-dev,
               libjpeg-dev,
               liblzma-dev,
               libzstd-dev,
               libwebp-dev,
               libxi-dev,
               zlib1g-dev,
               libdeflate-dev,
               liblerc-dev [!s390x !hppa !powerpc !ppc64 !sparc64 !i386],
               sphinx <!nodoc>
Standards-Version: 4.6.2
Homepage: https://libtiff.gitlab.io/libtiff/
Rules-Requires-Root: no

Package: libtiff6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libimager-perl (<< 1.022+dfsg)
Description: Tag Image File Format (TIFF) library
 libtiff is a library providing support for the Tag Image File Format
 (TIFF), a widely used format for storing image data.  This package
 includes the shared library.

Package: libtiffxx6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tag Image File Format (TIFF) library -- C++ interface
 libtiff is a library providing support for the Tag Image File Format
 (TIFF), a widely used format for storing image data.  This package
 includes the shared library for the experimental C++ interfaces.

Package: libtiff-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libc6-dev | libc-dev,
         libjbig-dev,
         libjpeg-dev,
         liblzma-dev,
         libzstd-dev,
         libwebp-dev,
         libtiff6 (= ${binary:Version}),
         libtiffxx6 (= ${binary:Version}),
         zlib1g-dev,
         libdeflate-dev,
         liblerc-dev [!s390x !hppa !powerpc !ppc64 !sparc64 !i386],
         ${misc:Depends}
Replaces: libtiff4-dev (<< 4.0.3-6~),
          libtiff5-alt-dev (<< 4.0.3-6~),
          libtiff5-dev (<< 4.0.10-1~)
Breaks: libtiff4-dev (<< 4.0.3-6~),
        libtiff5-alt-dev (<< 4.0.3-6~),
        libtiff5-dev (<< 4.0.10-1~)
Description: Tag Image File Format library (TIFF), development files
 libtiff is a library providing support for the Tag Image File Format
 (TIFF), a widely used format for storing image data.  This package
 includes the development files, static library, and header files.

Package: libtiff5-dev
Section: oldlibs
Depends: libtiff-dev (>= 4.0.10-1),
         ${misc:Depends}
Recommends: pkg-config
Architecture: any
Multi-Arch: same
Description: Tag Image File Format library (TIFF), development files (transitional package)
 libtiff is a library providing support for the Tag Image File Format
 (TIFF), a widely used format for storing image data.  This package
 includes the development files, static library, and header files.
 .
 This is a transitional package. It can safely be removed.

Package: libtiff-tools
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libtiff-opengl
Description: TIFF manipulation and conversion tools
 libtiff is a library providing support for the Tag Image File Format
 (TIFF), a widely used format for storing image data.  This package
 includes tools for converting TIFF images to and from other formats
 and tools for doing simple manipulations of TIFF images.  See also
 libtiff-opengl.

Package: libtiff-opengl
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: TIFF manipulation and conversion tools
 libtiff is a library providing support for the Tag Image File Format
 (TIFF), a widely used format for storing image data.  This package
 contains libtiff tools that depend upon opengl.  It complements the
 libtiff-tools package, which contains the libtiff tools that don't
 depend upon opengl.

Package: libtiff-doc
Section: doc
Depends: ${misc:Depends}, libjs-jquery, libjs-sphinxdoc, libjs-underscore
Architecture: all
Multi-Arch: foreign
Description: TIFF manipulation and conversion documentation
 libtiff is a library providing support for the Tag Image File Format
 (TIFF), a widely used format for storing image data.  This package
 contains documentation.
